/*
 * CEC server
 *
 */
#include "cec.h"
#include <stdio.h>
#include <arpa/inet.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>


int debug=1;

void usage(void) {
    fputs("Usage:\n",stderr);
    fputs("\tdbg send eth text\n",stderr);
    fputs("\tdbg recv eth\n",stderr);
    exit(1);
}

void
prmem(char *label, void *p, int len)	/* debugging print */
{
  uchar *cp = (uchar *)p;
  int i;
  cp = (uchar *)p;
	
  for (i = 0; i < len; i++) {
    if (!(i % 20)) fprintf(stderr,"\n%s (%4d): ",label,i);
    fprintf(stderr, " %02x", *cp++);
  }
  putc('\n',stderr);
}

int main(int argc,char **argv) {
  if (argc < 3) usage();

  if (!strcmp(argv[1],"send")) {
    struct Pkt q;

    if (netopen(argv[2])) fatal("netopen");

    memset(q.dst,0xff,6);
    q.etype = htons(CEC_ETYPE);
    q.type = Toffer;
    q.conn = 0;
    q.seq = 0;
    snprintf((char *)q.data,sizeof q.data,"%d %s",getpid(),argv[3]);
    q.len = strlen((char *)q.data);

    netsend(&q,HDRSIZ+q.len);
  } else if (!strcmp(argv[1],"sendto")) {
    struct Pkt q;
    if (netopen(argv[2])) fatal("netopen");
    parseether((char *)q.dst,argv[3]);

    q.etype = htons(CEC_ETYPE);
    q.type = Toffer;
    q.conn = 0;
    q.seq = 0;
    snprintf((char *)q.data,sizeof q.data,"%d %s",getpid(),argv[4]);
    q.len = strlen((char *)q.data);

    netsend(&q,HDRSIZ+q.len);
    
  } else if (!strcmp(argv[1],"recv")) {
    if (netopen(argv[2])) fatal("netopen");

    for (;;) {
      struct Pkt q;
      int n = netrecv();
      if (n < 0) exit(1);
      while ((n = netget(&q, sizeof q)) > 0) {
	prmem("pkt:",&q,n);
      }
    }
  } else if (!strcmp(argv[1],"probe")) {
    struct Shelf *s,*r;
    if (netopen(argv[2])) fatal("netopen");
    r = cec_probe(WAITSECS,0,NULL);
    for (s=r;s;s = s->next) {
      char aea[16];
      htoa(aea,s->ea,6);
      fprintf(stderr,"%d (%s) %s\n",s->shelfno,aea,s->str);
    }
    freeprobe(s);
  } else
    usage();
  return 0;
}

